##!/bin/bash

command_status=1
clear
PREFIX="/The/directory/that/the/mlab/will/be/installed/"


# Check for qmake
echo
echo "Checking for qmake ..." 
which qmake

if [ $? -eq $command_status ]
then
  echo "Please install qmake [1.07a (Qt 3.3.4) or higher] and run this check again."
  exit 1
else
  echo "qmake OK"
fi


# Check for QT3
echo
echo "Checking for QT3 ..." 
which designer-qt3

if [ $? -eq $command_status ]
then
  echo "Please install QT3 and run this check again."
  exit 1
else
  echo "QT3 OK"
fi



# Check for graphviz
echo
echo "Checking for graphviz ..." 
which dot

if [ $? -eq $command_status ]
then
  echo "Please install Graphviz and run this check again."
  exit 1
else
  echo "Graphviz OK"
fi

# Check for expect
echo
echo "Checking for expect ..." 
which expect

if [ $? -eq $command_status ]
then
  echo "Please install expect and run this check again."
  echo "For more info about \"expect\" go to :"
  echo "http://expect.nist.gov/"
  echo "A little more help... In my case it worked as:"
  echo "wget http://expect.nist.gov/old/expect-5.43.0.tar.gz"
  echo "vi INSTALL ... :)" 
  echo "./configure --with-tcl=/usr/lib/tcl8.4/ --with-tclinclude=/usr/include/tcl8.4/tcl-private/"
  echo "make && make install"
  exit 1
else
  echo "Expect OK"

fi


# Check for sed
echo
echo "Checking for sed ..." 
which sed

if [ $? -eq $command_status ]
then
  echo "Please install sed  and run this check again."
  exit 1
else
  echo "Sed OK"
 
fi


# Check for sshd
echo
echo "Checking for sshd ..." 
which sshd

if [ $? -eq $command_status ]
then
  echo "Please install sshd  and run this check again"
  exit 1
else
  echo "SSH ok"

fi


# Check for konsole
echo
echo "Checking for konsole ..." 
which konsole

if [ $? -eq $command_status ]
then
  echo "Please install konsole  and run this check again"
  exit 1
else
  echo "Konsole ok"
fi
echo
echo "You are ready to run the sh install.sh but first..."
echo
echo "You have to read the following CAREFULLY!"
echo "Press enter to continue..."
read otidipote

clear

echo "***********************************************"
echo "Very important tips before start installing mLab"
echo
echo "1. Make sure that the first thing that you will do with mLAB is "
echo " to distribute the .ssh/authorized_keys of the server "
echo " to every client. "
echo 
echo "2.You have add to the /root/.bashrc"
echo "these variables: MLABROOT,MLABSERVER and edit the PATH"
echo "to look like this :"
echo "Open your .bashrc and add the following lines"
echo "at the beginning (for example the 3rd line) of the file."
echo
echo "export MLABROOT=$PREFIX"
echo "export MLABSERVER=<your server's IP>"
echo "NOTE !!! If you are using 2 network cards"
echo "provide the ip that you are using to communicate "
echo "with the client nodes. (the wired one ...)"
echo "export PATH=\$PATH:\$MLABROOT/scripts/:\$MLABROOT"
echo 
echo "3. Make sure that you restart your bash konsole"
echo "after that ..."
echo
echo "4. Make sure that you have installed "
echo " libpcap-0.9.4 on your system. If you don't the injection"
echo " of custom packetis will be impossible."
echo 
echo "***********************************************"
echo
