##!/bin/bash
# /*************************************************************************
# /*# The mLab software 
#("software") is provided by NIST as a service and is expressly provided "AS 
# IS." NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
# INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY. NIST 
# DOES NOT REPRESENT OR WARRANT THAT THE OPERATION OF THE SOFTWARE WILL BE 
# UNINTERRUPTED OR ERROR-FREE, OR THAT ANY DEFECTS WILL BE CORRECTED. NIST 
# does not warrant or make any representations regarding the use of the 
# software or the results thereof, including but not limited to the 
# correctness, accuracy, reliability or usefulness of the software. Software 
# developed by NIST employees is not subject to copyright protection within 
# the United States. By using this software or by incorporating this software 
# into another product, you agree that you will indemnify and hold harmless 
# the United Sates Government for any and all damages or liabilities that 
# arise out of such use.
#
# mLab - Mobile Ad Hoc Network Test Bed
#
# Tom Karygiannis (karygiannis@nist.gov)
# Manos Antonakakis (manos@nist.gov)
# Mobile Ad Hoc Network Security Group
# National Institute Of Standards and Technology
# Main contact person for project
# Tom Karygiannis (karygiannis@nist.gov)
# URL: http://csrc.nist.gov/manet/
#
# */
# /*************************************************************************
command_status=1


echo "Is this the directory that the mlab should be installed in ?(Press 'y' if this is the default :[ $MLABROOT ])"
read PREFIX

case "$PREFIX" in
   y | Y ) 
   echo "Using the directory $MLABROOT"
   ;;
   
  * )  
echo "You have add to the /root/.bashrc"
echo "these variables: MLABROOT,MLABSERVER and edit the PATH"
echo "to look like this :"
echo "Open your .bashrc and add the following lines"
echo "at the beginning (for example the 3rd line) of the file."
echo
echo "export MLABROOT=/usr/local/mlab"
echo "export MLABSERVER=your_server's_IP"
echo "NOTE !!! If you are using 2 network cards"
echo "provide the ip that you are using to communicate "
echo "with the client nodes. (the wired one ...)"
echo "export PATH=\$PATH:\$MLABROOT/scripts/:\$MLABROOT"
exit 1
 
  ;;
esac      



mkdir -p $MLABROOT
cp -Rf * $MLABROOT/.
cd $MLABROOT
echo "compiling the mlab"
echo " #qmake mlab.pro "
qmake mlab.pro


if [ $? -eq $command_status ]
then
    echo "#qmake mlab.pro [error1]. Check your QT3 installation."
  exit 1
else
  echo "qmake mlab.pro done successfully "
fi



command_status=0
echo " #make"
make > make_out

find ./ -name "make_out"|xargs fgrep 'moc_sniffer.o'

if [ $? -eq $command_status ]
then
  echo "#make done successfully."
  echo
  echo "You just compiled mLab"
else
  echo "#make [error2]. Check your QT3 installation."
  exit 1
  
fi
echo
echo
echo "***********************************************"
echo "To run mlab just give the command:"
echo "# mlab"
echo "Installation complete"
echo "press enter to exit the installation"
read 

echo
echo
echo  
echo "***********************************************"
echo "mLab - Mobile Ad Hoc Network Test Bed"
echo "Tom Karygiannis (karygiannis@nist.gov)"
echo "Manos Antonakakis (manos@nist.gov)"
echo "Mobile Ad Hoc Network Security Group"
echo "National Institute Of Standards and Technology"
echo "Main contact persons for project"
echo "Tom Karygiannis (karygiannis@nist.gov) and"
echo "Manos Antonakakis (manos@nist.gov)"
echo "URL: http://csrc.nist.gov/manet"
echo "***********************************************"
exit 0    # Successful invocation of the script returns 0.
