/****************************************************************************
The mLab software ("software") is provided by NIST as a service and is expressly provided "AS 
IS." NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY. NIST 
DOES NOT REPRESENT OR WARRANT THAT THE OPERATION OF THE SOFTWARE WILL BE 
UNINTERRUPTED OR ERROR-FREE, OR THAT ANY DEFECTS WILL BE CORRECTED. NIST 
does not warrant or make any representations regarding the use of the 
software or the results thereof, including but not limited to the 
correctness, accuracy, reliability or usefulness of the software. Software 
developed by NIST employees is not subject to copyright protection within 
the United States. By using this software or by incorporating this software 
into another product, you agree that you will indemnify and hold harmless 
the United Sates Government for any and all damages or liabilities that 
arise out of such use.
*****************************************************************************/
#include <qapplication.h>
#include "amainform.h"
#include "sniffer.h"
#include <qstring.h>
#include <qinputdialog.h> 
#include <qstringlist.h> 
#include <qlineedit.h> 
#include <qfile.h>
#include<qdir.h>
#include <qtable.h> 
#include <qsocket.h>
#include <qtextview.h>
#include <qprocess.h>
#include <qstatusbar.h> 
#include <qthread.h> 
#include <qtabdialog.h>
#include <qimage.h> 
#include <qpicture.h> 
#include <qpixmap.h> 
#include <qlcdnumber.h>
#include <qspinbox.h> 
#include <qcolor.h> 
#include <qcombobox.h> 
#include <qcheckbox.h> 
#include <qthread.h> 
#include <qerrormessage.h> 
#include <qtimer.h> 
#include <math.h>

void  NetworkForm::init()
{

    runme();  //update node table index

    
}

void NetworkForm::runme()
{

    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
     QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/nodes" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    QFileInfo *fi;

    

    int row=0;
    
    
    while ( (fi = it.current()) != 0 ) {
	text=fi->fileName().latin1();
	
	NodeTable->setText(row,0,text);
	
	QString my_path1;
	my_path1=getenv ("MLABROOT");
	my_path1.append( "/network/nodes" );
	
	QDir::setCurrent (my_path1);
	
	QStringList lines;
	QFile file(text);
	
	if ( file.open( IO_ReadOnly ) ) {
	    QTextStream stream( &file );
	    QString line;
	    // int i = 1;
	    while ( !stream.atEnd() ) {
		line = stream.readLine(); // line of text excluding '\n'
		QString s = line.section( "__", 4, 4 );  // s == Wired IP
		NodeTable->setText(row,1,s);

		lines += line;
	    }
	    file.close();
	}
	
	++it;
	row++;
    }
}


void NetworkForm::updateValues()
{
    
    system("rm -rf $MLABROOT/network/tmp/*");
    QProcess *proc; 
    int val=0;
    proc = new QProcess( this );
    proc->addArgument( "network_info.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));
    collecting_values->setProgress(5);
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->updateValues<Fatal error Could not start the uic command. script name : network_info.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Collecting values from remote node ..." );
	collecting_values->setProgress(val);
	sleep(1);
	val=val+5;
    }      
   val=val+5;
    IPtables();
    collecting_values->setProgress(val);
    IProutes();
    val=val+5;
     collecting_values->setProgress(val);
    wirellessInfo();
    val=100;
     collecting_values->setProgress(val);

}


void NetworkForm::IPtables()
{
    // update table of nodes
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
        QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---IPTables info
    
        QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/info_iptables" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	    IPTables->append(line);
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
    
}


void NetworkForm::IProutes()
{
    

}


void NetworkForm::wirellessInfo()
{
txpower();

Wlan0();
Channel();
Essid();
advWirelessInfo();
advWirelessInfo1();
advWirelessInfo2();
advWirelessInfo3();
advWirelessInfo4();
advWirelessInfo5();
wAODVinfo();

}

void NetworkForm::advWirelessInfo()
{
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    
     QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/quality" );
    
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   quality->setText(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;

}


void NetworkForm::advWirelessInfo1()
{
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    
    //---Wireless info txpower
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/cell" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   cell->setText(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::advWirelessInfo2()
{
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/MAC" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   MAC->setText(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::advWirelessInfo3()
{
  QString text;
  QDir d;
  d.setFilter( QDir::Files | QDir::NoSymLinks );
  d.setSorting( QDir::Name );
  
  QString my_path;
  my_path=getenv ("MLABROOT");
  my_path.append( "/network/tmp/" );
  
  QDir::setCurrent (my_path);
  
  const QFileInfoList *list = d.entryInfoList();
  QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/noise" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   noise->setText(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::advWirelessInfo4()
{
  QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
        QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/bitrate" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   bitrate->setText(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::advWirelessInfo5()
{
  QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/signal" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   signal_l->setText(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::wAODVinfo()
{
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/info_aodv" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	   IPRoutes->append(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;

}





void NetworkForm::txpower()
{
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
        QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info txpower
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/txpower" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	    TxpowerlCD->display(line);
	
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::Essid()
{

    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info essid
     QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/essid" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	    essid->setText(line);
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::Channel()
{

    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
        QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless info channel
    
    QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/frequency" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	// int i = 1;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	    channel->setText(line);
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}


void NetworkForm::Wlan0()
{
       QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
        QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/tmp/" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    
    int row=0;
    QStringList lines;
    QString s;  
    
    //---Wireless General info about adapter
    
        QString my_path1;
    my_path1=getenv ("MLABROOT");
    my_path1.append( "/network/tmp/info_wlan" );
    
    QFile file(my_path1);
    
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); 
	    wlan0->append(line);
	    lines += line;
	}
	file.close();
    }
    
    ++it;
    row++;
}



void NetworkForm::current_node()
{
    setkey->clear();
    setessid->clear();
    IPTables->clear();
    IPRoutes->clear();
    essid->clear();
    channel->clear();
    wlan0->clear();
//    scann->clear();
    TxpowerlCD->display("");
    bitrate->clear();
    MAC->clear();
    cell->clear();
    noise->clear();
    quality->clear();
    signal_l->clear();
    IPRoutes->clear();
     collecting_values->setProgress(0);
node->setText( NodeTable->text(NodeTable->currentRow(),1) );
}


void NetworkForm::setTxpower()
{
 QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "set_txpower.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));
    proc->addArgument(settxpowerValue->text());
 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->setTxpower<Fatal error Could not start the uic command. script name : set_txpower.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Setting the txpower ..." );
	sleep(1);
    }      
}


void NetworkForm::setKEY()
{
 QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "set_key.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));
    proc->addArgument(setkey->text());
 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->setKEY<Fatal error Could not start the uic command. script name : set_KEY.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Setting the new KEY ..." );
	sleep(1);
    }      
}


void NetworkForm::setESSID()
{
     QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "set_essid.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));
    proc->addArgument(setessid->text());
 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->setESSID<Fatal error Could not start the uic command. script name : set_essid.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Setting the new ESSID ..." );
	sleep(1);
    }  

    
}


void NetworkForm::setTxpowerAuto()
{
     QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "set_txpower.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));
    proc->addArgument("auto");
 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->setTxpowerAuto<Fatal error Could not start the uic command. script name : set_txpower.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Setting the txpower to auto..." );
	sleep(1);
    }      

}


void NetworkForm::setKEYoff()
{
QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "set_key.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));
    proc->addArgument("off");
 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->setKEYoff<Fatal error Could not start the uic command. script name : set_KEY.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Removing the KEY ..." );
	sleep(1);
    }      
}






void NetworkForm::ResetMalicious()
{
 QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "FL.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));

 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->ResetMalicious<Fatal error Could not start the uic command. script name : FL.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Flashing the iptables on remote node  ..." );
	sleep(1);
    }      
}


void NetworkForm::openterminal()
{
 QProcess *proc; 
    proc = new QProcess( this );
    proc->addArgument( "open_terminal.sh" );
    proc->addArgument( NodeTable->text(NodeTable->currentRow(),1));

 
    
    
    if ( !proc->start() ) {
	// error handling
	printf( "	function ->openterminals<Fatal error Could not start the uic command. script name : open_terminal.sh . Quit\n <--- \n" );
    }

    while ( proc->isRunning () == TRUE ){
	qDebug( "Opening remote terminal  ..." );
	sleep (2);
    }      
}
