#!/bin/sh
#
# malicious_activity - SIMPLE script for creating malicious activity for 
# Linux 2.4.x and iptables hosts. Enjoy ...
#
# Manos Antonakakis (manos@nist.gov)
#
# usage: malicious_activity.sh 	$1_type_of_attack
#				$2_protocol_to_attack_or_packet_loss_duration
#				$3_Port_or__packet_loss_duration_time_window
#				

z=0
time_repeat_packet_loss=10


case "$1" in


  "Packet_Loss" ).
	echo
	echo "Packet Loss"
	##########################
	# Packet loss for a small
	# time window (5 sec) ... 
	# then set everything back
	# to normal but after some
	# time (35 sec) we have 
	# packet loss again. Do it 
	# for $time_repeat_packet_loss
	#

	while [ z -lt ]
	do
		echo "0" > /proc/sys/net/ipv4/ip_forward
		sleep 5
		echo "1" > /proc/sys/net/ipv4/ip_forward
		sleep 35
		z=$(($z+1))
	done


  ;;

  

  "Incomming" )
	echo
	echo "Incomming"
	
	##########################
	# INPUT chain
	#
	#
	#iptables -A INPUT -p ALL -i wlan0 -d 192.168.10.0/24 -j DROP
  
  
  ;;
  
  
  
  "Outgoing" )
	echo
	echo "Outgoing"

	###############################
	# OUTPUT chain
	#
	#
	#iptables -A OUTPUT -p ALL -s 192.168.106.0/24 -d 192.168.10.0/24 -j DROP

  ;;
  
  
  
  "Both" )
  echo
  echo "Both"

  ;;

  
  
   * )
   # Default option.      
   echo
   echo "Not yet in database. Try something from the Following:"
   echo "Packet Loss"
   echo "Incomming"
   echo "Outgoing"
   echo "Both"
  ;;

esac



# iptables -P INPUT DROP
# iptables -P OUTPUT DROP
# iptables -P FORWARD DROP


# -p : protocol 
#iptables -A INPUT -p ALL -i wlan0 -d 192.168.10.0/24 -j DROP



###############################
# TCP action main Fanction.
# This function will help us 
# create blocking rules for the
# localhost
# call this function:
# tcp_act

tcp_act ()
{ 
	echo "Entering the tcp_act function ..."
	#
	# TCP Rules
	#

	 iptables -A FORWARD -p tcp -s 192.168.106.23 --dport 1016 -j DROP
	
} 


###############################
# UDP action main Fanction.
# This function will help us 
# create blocking rules for the
# localhost
# call this function:
# udp_act

udp_act ()
{ 
  echo "Entering the udp_act function ..."
  
	#
	# UDP Rules
	#
	
	# Create the new Chain
	iptables -N udp_packets
	
	# Network Area
	iptables -A udp_packets -p UDP -s 0/0 --source-port 53 -j DROP
	iptables -A udp_packets -p UDP -s 192.168.106.0/0 --source-port 123 -j DROP
	iptables -A udp_packets -p UDP -s 192.168.106.26/0 --source-port 2074 -j DROP
	
	# Single Node
	iptables -A udp_packets -p UDP -s 192.168.106.29 --source-port 654 -j DROP
	iptables -A udp_packets -p UDP -s 192.168.106.23 --source-port 654 -j DROP
	
	# In which tables we should apply the above Rules
	iptables -A INPUT -p TCP -i wlan0 -j  udp_packets
	iptables -A FORWARD -p TCP -i wlan0 -j  udp_packets
  
} 

###############################
# ICMP action main Fanction.
# This function will help us 
# create blocking rules for the
# localhost
# call this function:
# icmp_act

icmp_act ()
{ 
	echo "Entering the icmp_act function ..."
	
	#
	# ICMP Rules
	#
	
	# Create the new Chain
	iptables -N icmp_packets
	
	# Network Area
	iptables -A icmp_packets -p ICMP -s 0/0 --icmp-type 8 -j DROP
	iptables -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j DROP
	iptables -A icmp_packets -p ICMP -s 0/0 --icmp-type 11 -j DROP
	iptables -A icmp_packets -p ICMP -s 192.168.106.22/0 --icmp-type 22 -j DROP
	
	# Single Node
	iptables -A icmp_packets -p ICMP -s 192.168.106.25 --icmp-type 11 -j DROP
	iptables -A icmp_packets -p ICMP -s 192.168.106.25 --icmp-type 11 -j DROP
	
	# In which tables we should apply the above Rules
	iptables -A INPUT -p TCP -i wlan0 -j icmp_packets
	iptables -A FORWARD -p TCP -i wlan0 -j icmp_packets
	
  
} 


###############################
# reset_chain action fanction.
# This function will help us 
# reseting any existing rules
# within the iptables.
# call this function:
# reset_chain

reset_chain ()
{ 
  echo "Entering the reset_chain function ..."
  
  # Flush the BASIC chains
  iptables -F FORWARD
#   iptables -F INPUT
  
  # Flush the chains we have created
#   iptables -F udp_packets
#   iptables -F icmp_packets
#   iptables -F tcp_packets
  
  # Delete on of the chain we have created
  # NOTE : DO NOT DELETE BASIC CHAINS 
  # 

  
  # iptables -X tcp_packets
  
  
}
