#!/bin/bash
# start_malicious.sh  

# This script is responsible for Basic [ IP table based ] attack and packet loss
# $1_NodeDestIP <The host that will be malicious>
# $2_NodeSourceIP <The node that the attack will effect>
# $3_Time
# $4_Network_activity_type_AttType1
# $5_Protocol_Type-AttType2
# $6_SPort
# $7_DPort
# $8_MAC
# $9_NodeDestIP2
# $10_NodeDestIP3
# 
# 	iptables -A FORWARD -p $5 -s $2 --dport $7 -j DROP
# 	iptables -A INPUT -p $5 -s $2 --dport $7 -j DROP
# 	iptables -A OUTPUT -p $5 -s $2 --dport $7 -j DROP
#	iptables -A icmp_packets -p ICMP -s $2 --icmp-type 11 -j DROP
#	iptables -A FORWARD -m mac --mac-source $8 -j DROP
#	iptables -A INPUT -m mac --mac-source $8 -j DROP
#	iptables -A OUTPUT -m mac --mac-source $8 -j DROP
# 	iptables -A INPUT -p ALL -i wlan0 -d 192.168.10.0/24 -j DROP
# 	iptables -A OUTPUT -p ALL -s 192.168.106.0/24 -d 192.168.10.0/24 -j DROP


# Attack name:tcp_1011
# Source node:Node23
# Destination node:Node28
# Time until Attack:20

# Network activity type:Incomming
# Protocol Type:TCP
# Source Port:1011
# Destination Port:1011
# Extentions:
# Remote MAC:
# Remote Dest Node 2:Node22
# Remote Dest Node 3:Node22


case "$4" in


  "Packet_Loss" )
	echo
	echo "Packet Loss @ The Host"
##########################
# NOTE Packet loss for a small
# time window (5 sec) ... 
# then set everything back
# to normal but after some
# time (35 sec) we have 
# packet loss again. Do it 
# for $time_repeat_packet_loss
# Change it any way you see best 
# according to your application 
#
##########################
	scp $MLABROOT/scripts/packet_loss.sh  root@$1:/root/mlabclient/packet_loss.sh
	ssh root@$1 '(sh  /root/mlabclient/packet_loss.sh )'&
  ;;

  

  "Incomming" )
	echo
	echo "Incomming Activity"
	##########################
	# Incomming Activity
	#
	#
	case "$5" in
		"tcp" )
			# Block the TCP activity 
			echo "Blocking the Incomming TCP activity"
	
			echo "iptables -A FORWARD -p tcp -s $2 --dport $7 -j DROP"> /tmp/tcp.sh
			echo "iptables -A INPUT -p tcp -s $2 --dport $7 -j DROP">> /tmp/tcp.sh
			
			scp /tmp/tcp.sh root@$1:/tmp/tcp.sh
			ssh root@$1 '(sh  /tmp/tcp.sh )'&

		;;
		"udp"  )
			# Block the UDP activity 
			echo "Blocking the Incomming UDP activity"
	
			echo "iptables -A FORWARD -p udp -s $2 --dport $7 -j DROP"> /tmp/udp.sh
			echo "iptables -A INPUT -p udp -s $2 --dport $7 -j DROP">> /tmp/udp.sh
			
			scp /tmp/udp.sh root@$1:/tmp/udp.sh
			ssh root@$1 '(sh  /tmp/udp.sh )'&
	
		;;
		"icmp" )
			# Block the ICMP activity 
			echo "Blocking the Incomming ICMP activity"
	
			echo "iptables -A FORWARD -p ICMP -s $2 --icmp-type 11 -j DROP"> /tmp/icmp.sh
			echo "iptables -A FORWARD -p ICMP -s $2 --icmp-type 8 -j DROP">> /tmp/icmp.sh
			echo "iptables -A FORWARD -p ICMP -s $2 --icmp-type 22 -j DROP">> /tmp/icmp.sh
			
			echo "iptables -A INPUT -p ICMP -s $2 --icmp-type 11 -j DROP">> /tmp/icmp.sh
			echo "iptables -A INPUT -p ICMP -s $2 --icmp-type 8 -j DROP">> /tmp/icmp.sh
			echo "iptables -A INPUT -p ICMP -s $2 --icmp-type 22 -j DROP">> /tmp/icmp.sh
			
			scp /tmp/icmp.sh root@$1:/tmp/icmp.sh
			ssh root@$1 '(sh  /tmp/icmp.sh )'&
		;;
		* )
			echo "Something is not good ... <error1>"
		;;
	esac
  ;;
  
  
  
  "Outgoing" )
	echo
	echo "Outgoing Activity"
	###############################
	# Outgoing Activity
	#
	#
	#
	case "$5" in
		"tcp" )
			# Block the TCP activity 
			echo "Blocking the Outgoing TCP activity"
	
			echo "iptables -A OUTPUT -p tcp -s $2 --dport $7 -j DROP"> /tmp/tcp.sh
			
			scp /tmp/tcp.sh root@$1:/tmp/tcp.sh
			ssh root@$1 '(sh  /tmp/tcp.sh )'&

		;;
		"udp"  )
			# Block the UDP activity 
			echo "Blocking the Outgoing UDP activity"
	
			echo "iptables -A OUTPUT -p udp -s $2 --dport $7 -j DROP"> /tmp/udp.sh
			
			scp /tmp/udp.sh root@$1:/tmp/udp.sh
			ssh root@$1 '(sh  /tmp/udp.sh )'&
	
		;;
		"icmp" )
			# Block the ICMP activity 
			echo "Blocking the Outgoing ICMP activity"
r 
			echo "iptables -A OUTPUT -p ICMP -s $2 --icmp-type 11 -j DROP"> /tmp/icmp.sh
			echo "iptables -A OUTPUT -p ICMP -s $2 --icmp-type 8 -j DROP">> /tmp/icmp.sh
			echo "iptables -A OUTPUT -p ICMP -s $2 --icmp-type 22 -j DROP">> /tmp/icmp.sh
			
			scp /tmp/icmp.sh root@$1:/tmp/icmp.sh
			ssh root@$1 '(sh  /tmp/icmp.sh )'&
		;;
		* )
			echo "Something is not good ... <error2>"
		;;
	esac

  ;;
  
  
  
  "Both" )
	echo
	echo "Incomming Activity & Outgoing Activity"
	##########################
	# Incomming Activity &
	# Outgoing Activity
	#

	
	case "$5" in
	#Type_Of_Network_Connection
	
		"tcp" )
			# Block All the TCP activity 
			echo "Blocking All the TCP activity"
	
			echo "iptables -A FORWARD -p tcp -s $2 --dport $7 -j DROP"> /tmp/tcp.sh
			echo "iptables -A INPUT -p tcp -s $2 --dport $7 -j DROP">> /tmp/tcp.sh
			echo "iptables -A OUTPUT -p tcp -s $2 --dport $7 -j DROP">> /tmp/tcp.sh
			
			scp /tmp/tcp.sh root@$1:/tmp/tcp.sh
			ssh root@$1 '(sh  /tmp/tcp.sh )'&
		;;
		"udp"  )
			# Block All the UDP activity 
			echo "Blocking All the UDP activity"
	
			echo "iptables -A FORWARD -p udp -s $2 --dport $7 -j DROP"> /tmp/udp.sh
			echo "iptables -A INPUT -p udp -s $2 --dport $7 -j DROP">> /tmp/udp.sh
			echo "iptables -A OUTPUT -p udp -s $2 --dport $7 -j DROP">> /tmp/udp.sh
			
			
			scp /tmp/udp.sh root@$1:/tmp/udp.sh
			ssh root@$1 '(sh  /tmp/udp.sh )'&
	
		;;
		"icmp" )
			# Block  All the ICMP activity 
			echo "Blocking All the ICMP activity"
	
			echo "iptables -A FORWARD -p ICMP -s $2 --icmp-type 11 -j DROP"> /tmp/icmp.sh
			echo "iptables -A FORWARD -p ICMP -s $2 --icmp-type 8 -j DROP">> /tmp/icmp.sh
			echo "iptables -A FORWARD -p ICMP -s $2 --icmp-type 22 -j DROP">> /tmp/icmp.sh
			
			echo "iptables -A INPUT -p ICMP -s $2 --icmp-type 11 -j DROP">> /tmp/icmp.sh
			echo "iptables -A INPUT -p ICMP -s $2 --icmp-type 8 -j DROP">> /tmp/icmp.sh
			echo "iptables -A INPUT -p ICMP -s $2 --icmp-type 22 -j DROP">> /tmp/icmp.sh
			
			echo "iptables -A OUTPUT -p ICMP -s $2 --icmp-type 11 -j DROP"> /tmp/icmp.sh
			echo "iptables -A OUTPUT -p ICMP -s $2 --icmp-type 8 -j DROP">> /tmp/icmp.sh
			echo "iptables -A OUTPUT -p ICMP -s $2 --icmp-type 22 -j DROP">> /tmp/icmp.sh
			
			scp /tmp/icmp.sh root@$1:/tmp/icmp.sh
			ssh root@$1 '(sh  /tmp/icmp.sh )'&
		;;
		* )
		echo "Something is not good ... <error3>"
		;;
	esac
  ;;

  "DOS" )
	echo
	echo "DOS"


  ;;  
  
   * )
   # Default option.      
   echo
   echo "Not yet in database. Try something from the Following:"
   echo "Packet Loss"
   echo "Incomming"
   echo "Outgoing"
   echo "Both"
   echo "DOS"
  ;;

esac


exit 0
