#!/bin/bash
# start_routing.sh ip_of_remote_node

command_status=0

# for the host in order to avoid tunneling of packets 
# through the eth0 interface
iptables -P FORWARD DROP && iptables -t mangle -P FORWARD DROP
echo "0" > /proc/sys/net/ipv4/ip_forward

# This command is placed here in order to avoid tunneling of packets 
# through the eth0 interface:
# NOTE the `$MLABSERVER` will not allow any forwording through him.

ssh root@$1 '( ip route change 192.168.10.0/24 via '$MLABSERVER'; ip route del default )'

echo > /tmp/test_routing


ssh root@$1 '(cd /root/mlabclient ; sh routing/start_gateway.sh ; exit 0 )'&
sleep 2
ssh root@$1 '( ps -A ; exit 0 )' > /tmp/test_routing
# This is happening because the client need some time to grant remote root access so ...
 
find /tmp -name test_routing |xargs fgrep "aodv"


if [ $? -eq $command_status ]
then
  echo "The routing algorithm started"
  exit 1
else
  echo "The routing algorithm didn't started"
  exit 0
fi
