/****************************************************************************
The mLab software ("software") is provided by NIST as a service and is expressly provided "AS 
IS." NIST MAKES NO WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR STATUTORY, 
INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTY OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE, NON-INFRINGEMENT AND DATA ACCURACY. NIST 
DOES NOT REPRESENT OR WARRANT THAT THE OPERATION OF THE SOFTWARE WILL BE 
UNINTERRUPTED OR ERROR-FREE, OR THAT ANY DEFECTS WILL BE CORRECTED. NIST 
does not warrant or make any representations regarding the use of the 
software or the results thereof, including but not limited to the 
correctness, accuracy, reliability or usefulness of the software. Software 
developed by NIST employees is not subject to copyright protection within 
the United States. By using this software or by incorporating this software 
into another product, you agree that you will indemnify and hold harmless 
the United Sates Government for any and all damages or liabilities that 
arise out of such use.
*****************************************************************************/
#include <qapplication.h>
#include "amainform.h"
#include "network.h"
#include <qstring.h>
#include <qinputdialog.h> 
#include <qstringlist.h> 
#include <qlineedit.h> 
#include <qfile.h>
#include<qdir.h>
#include <qtable.h> 
#include <qsocket.h>
#include <qtextview.h>
#include <qprocess.h>
#include <qstatusbar.h> 
#include <qthread.h> 
#include <qtabdialog.h>
#include <qimage.h> 
#include <qpicture.h> 
#include <qpixmap.h> 
#include <qlcdnumber.h>
#include <qspinbox.h> 
#include <qcolor.h> 
#include <qcombobox.h> 
#include <qcheckbox.h> 
#include <qthread.h> 
#include <qerrormessage.h> 
#include <qtimer.h> 
#include <qregexp.h> 
#include <qcstring.h> 
#include <qtable.h> 


void sniffer::init()
{
    
    sniffrunme();
    
}

void sniffer::sniffrunme()
{
    // update table of nodes
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/nodes" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    QFileInfo *fi;
    
    
    snifferSource->clear ();
    
    
    int row=0;
    
    
    while ( (fi = it.current()) != 0 ) {
	text=fi->fileName().latin1();
	snifferSource->insertItem(text,row);
	++it;
	row++;
    }
    
}
/*
  **************************************************************************************************************
												    Parse function 
  **************************************************************************************************************
*/

void sniffer::parse()
{
    clear_table();
    bool packet_is_accepted = TRUE;
    sniferTable->removeColumn(0);
    sniferTable->removeColumn(1);
    parse_bar->setProgress(0);
 
    sniferTable->insertColumns(0);
    sniferTable->insertColumns(1);
    
    QHeader *th = sniferTable->horizontalHeader();
    th->setLabel( 1, "Ethernet  Destination and Source" );
    th->setLabel( 0, "ID" );
    sniferTable->removeColumn(2);
    
    QStringList lines;
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/sniffer/sniff_log" );
    int z=0;
    QFile file(my_path);
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	QString about_to_show;
	int i = 1;
	int row=0;
	
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); // line of text excluding '\n'	    ;	    
	    if( line.startsWith( "# New packet with id" ) == TRUE){	    
		
		sniferTable->insertRows(row);
		int end = line.find( QRegExp(" #"), 0 );
		int str = line.find( QRegExp("mber "), 0 );		
		sniferTable->setText(row,0,line.mid( str+4, end)); // the ID number only at the first field
		about_to_show="Ethernet";
		
		// I am at : # New packet with id ... and overall packet number ... #
		lines += line;
		line = stream.readLine();
		// Just moved one line
		
		lines += line;
		line = stream.readLine();
		// Just moved one line
		
		// I am at :	l1source
		
		QString packetID;
		
		packetID = line.remove( 0, 12);
		packetID.append(" --> ");
		
		lines += line;
		line = stream.readLine();
		// Just moved one line
		parse_bar->setProgress(z);
		z=z+1;
		// I am at :	l1dest
		
		packetID.append(line.remove( 0, 7));
		
		sniferTable->setText(row,1,packetID);
		row++;
		packet_is_accepted=FALSE;
		
	    }
	    else{
		// scip the line
		packet_is_accepted=TRUE;
	    }    
	    i++;
	    lines += line;

	}
	file.close();
    }  
    parse_bar->setProgress(100);
}


/*
  **************************************************************************************************************
																	   Analyze one packet function 
  **************************************************************************************************************
*/


void sniffer::showPacket()
{
    QStringList lines;
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/sniffer/sniff_log" );
    
    QFile file( my_path );
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	QString about_to_show;
	int i = 1;
	
	int row=0;
	sniffL1->clear();
	sniffL2->clear();
	sniffL3->clear();
	sniffL4->clear();
	sniffHEX->clear();
	QString locate_this = sniferTable->text(sniferTable->currentRow(),0);
	bool read_current_packet = TRUE;
	QString current;
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); // line of text excluding '\n'	  
	    int end = line.find( QRegExp(" #"), 0 );
	    int str = line.find( QRegExp("mber "), 0 );
	    
	    if ( ! line.isEmpty() ) 
		current = line.mid(str+4, end);
	    else
		current = "";
	    
	    
	    if( strcmp(locate_this,current) == 0 ){
	//	qDebug( "In -> 1..." );
		lines += line;
		line = stream.readLine();
		QString current_line;
		if ( ! line.isEmpty() ) 
		    current_line = line.left( 4 );
		else
		    current_line = "";
		
		
		if ( strcmp(current_line,"****") == 0) {
		    bool Ethernet  = FALSE;
		    bool IP = FALSE;
		    bool UDP  = FALSE;
		    bool TCP = FALSE;
		    bool AODV = FALSE;
	//	    qDebug( "IN ->  2..." );
		    // move one line
		    while(  read_current_packet == TRUE ){
			line = stream.readLine();
			if (!line.isEmpty() ){
			    //Type of Packet Header
			    if (  line.left( 12 ) == "Destination:" ) {
				sniffL1->append( line.latin1());
				// Ethernet Header
				qDebug( "  Ethernet Header " );
				Ethernet = TRUE;
// 				qDebug( "IN -> 3..." );
				
				// go until the next empty line 
				while(Ethernet  == TRUE){
				    line = stream.readLine();
// 				    qDebug( "In-> ETHERNET.1 ..." );
				    if (!line.isEmpty() ){
// 					qDebug( "In-> Ethernet Header.2 ..." );
					sniffL1->append( line.latin1());
// 					qDebug( "In-> Ethernet Header.3 ..." );
					i++;
					lines += line;
					
					
				    }
				    else{	   
// 					qDebug( "In-> Ethernet Header.4 ..." );
					Ethernet = FALSE;
					lines += line;
				    }				    
				}
			    }
			    else if ( strcmp(line.latin1(), "*****IP HEADER*******") == 0) {
				// IP Header
				qDebug( " IP Header " );
				IP = TRUE;
// 				qDebug( "In-> 4..." );
				
				// go until the next empty line 
				while(IP  == TRUE){
				    line = stream.readLine();
// 				    qDebug( "In-> IP.1 ..." );
				    if (!line.isEmpty() ){
/*					qDebug( "In-> IP Header.2 ..." );*/
					sniffL2->append( line.latin1());
// 					qDebug( "In-> IP Header.3 ..." );
					i++;
					lines += line;
					
					
				    }
				    else{	   
// 					qDebug( "In-> IP Header.4 ..." );
					IP= FALSE;
					lines += line;
				    }				    
				}
				
			    }
			    else if ( strcmp(line.latin1(),"*****UDP HEADER*******") == 0) {
				// UDP Header
				line = stream.readLine();
				qDebug( " UDP Header " );
				UDP = TRUE;
// 				qDebug( "In-> 5..." );
				
				// go until the next empty line 
				while(UDP  == TRUE){
				    line = stream.readLine();
// 				    qDebug( "In-> UDP.1 ..." );
				    if (!line.isEmpty() ){
// 					qDebug( "In-> UDP Header.2 ..." );
					sniffL3->append( line.latin1());
// 					qDebug( "In-> UDP Header.3 ..." );
					i++;
					lines += line;
					
					
				    }
				    else{	   
// 					qDebug( "In-> UDP Header.4 ..." );
					UDP = FALSE;
					lines += line;
				    }				    
				}
				
			    }
			    else if (strcmp(line.latin1(),"*****TCP HEADER*******") == 0 ) {
				// TCP Header
				line = stream.readLine();
				qDebug( " TCP Header " );
				TCP = TRUE;
// 				qDebug( "In-> 6..." );
				
				// go until the next empty line 
				while(TCP  == TRUE){
				    line = stream.readLine();
// 				    qDebug( "In-> TCP.1 ..." );
				    if (!line.isEmpty() ){
// 					qDebug( "In-> TCP Header.2 ..." );
					sniffL3->append( line.latin1());
// 					qDebug( "In-> TCP Header.3 ..." );
					i++;
					lines += line;
					//line = stream.readLine();
					
				    }
				    else{	   
// 					qDebug( "In-> TCP Header.4 ..." );
					TCP= FALSE;
					lines += line;
				    }				    
				}
			    }
			    else if ( strcmp( line.left( 4 ),"AODV") == 0 ) {
				//AODV Header
				//  line = stream.readLine();
				qDebug( "AODV Header " );
				AODV= TRUE;
// 				qDebug( "In-> 7..." );
				
				// go until the next empty line 
				while(AODV  == TRUE){
				    line = stream.readLine();
// 				    qDebug( "In-> AODV.1 ..." );
				    if (!line.isEmpty() ){
// 					qDebug( "In-> AODV Header.2 ..." );
					sniffL4->append( line.latin1());
// 					qDebug( "In-> AODV Header.3 ..." );
					i++;
					lines += line;
					//line = stream.readLine();
					
				    }
				    else{	   
// 					qDebug( "In-> AODV Header.4 ..." );
					AODV = FALSE;
					lines += line;
				    }				    
				}
			    }
			    else if (strcmp( line.left( 4 ),"Leng") == 0 ) {
				//Length of this packet 
				// Just don't do anything
// 				qDebug( "In->  Leng..." );
				lines += line;
			    }
			    else if (strcmp( line.left( 3 ),"# Ne") == 0 ){
				//exit .... This is next packet 
				read_current_packet= FALSE;
// 				qDebug( "In-> # Ne <-------------------------------- I EXIT HERE ..." );
				sleep (2);
				lines += line;
				
				
			    }
			    else if (strcmp( line.left( 4 ),"1st ") == 0 ){
// 				qDebug( "In-> HEX..." );
				
				//Hex form of packet
				//1st 16->:
// 				qDebug( "1st 16->:" );
				sniffHEX->setText( line.remove( 0, 9));
				i++;
				lines += line;
				line = stream.readLine();			
				
				//2nd 16->:
// 				qDebug( "2nd 16->:" );
				sniffHEX->append( line.remove( 0, 8));
				i++;
				lines += line;
				line = stream.readLine();	
				//3rd 16->:
// 				qDebug( "3rd 16->:" );
				sniffHEX->append( line.remove( 0, 8));
				i++;
				lines += line;
				line = stream.readLine();
				
				//4th 16->:
// 				qDebug( "4th 16->:" );
				sniffHEX->append( line.remove( 0, 8));
				i++;
				lines += line;
				line = stream.readLine();
				
				
				if ( !line.isEmpty()  && strcmp( line.left( 4 ),"5th ") == 0 ){ 
				    //5th 16->:
// 				    qDebug( "5th 16->:" );
				    sniffHEX->append( line.remove( 0, 8));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				if (!line.isEmpty()  && strcmp( line.left( 4 ),"6th ") == 0 ){ 
				    //6th 16->:
// 				    qDebug( "6th 16->:" );
				    sniffHEX->append( line.remove( 0, 8));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				if (!line.isEmpty()  && strcmp( line.left( 4 ),"7th ") == 0 ){ 
				    //5th 16->:
// 				    qDebug( "7th 16->:" );
				    sniffHEX->append( line.remove( 0, 8));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				if (!line.isEmpty()  && strcmp( line.left( 4 ),"8th ") == 0 ){ 
				    //8th 16->:
// 				    qDebug( "8th 16->:" );
				    sniffHEX->append( line.remove( 0, 8));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				if (!line.isEmpty()  && strcmp( line.left( 4 ),"9th ") == 0 ){ 
				    //9th 16->:
// 				    qDebug( "9th 16->:" );
				    sniffHEX->append( line.remove( 0, 8));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				if (!line.isEmpty()  && strcmp( line.left( 4 ),"10th") == 0 ){ 
				    //10th 16->:
// 				    qDebug( "10th 16->:" );
				    sniffHEX->append( line.remove( 0, 9));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				if (!line.isEmpty()  && strcmp( line.left( 4 ),"11th") == 0 ){ 
				    //11th 16->:
// 				    qDebug( "11th 16->:" );
				    sniffHEX->append( line.remove( 0, 9));
				    
				    i++;
				    
				    lines += line;
				    
				    line = stream.readLine();
				    
				    
				    
				}
				else
				{
				    
				}
				
				read_current_packet= FALSE;
			    }
			    else {
				qDebug( "In-> 12..." );
				if(Ethernet  == TRUE){
// 				    qDebug( "In-> else  Ethernet  == TRUE ..." );
				}
				else if(IP  == TRUE){
// 				    qDebug( "In-> else  IP  == TRUE ..." );
				}
				else if(UDP  == TRUE){
// 				    qDebug( "In-> else UDP  == TRUE ..." );
				}
				else if(TCP  == TRUE){
// 				    qDebug( "Mpika else TCP  == TRUE ..." );
				}
				else if(AODV  == TRUE){
// 				    qDebug( "In-> else  AODV  == TRUE ..." );
				}
				else{
				    qDebug( "In-> else  NOT looking good  == TRUE ..." );    
				    // Unknown type of Packet
				}
				lines += line;
			    }
// 			    qDebug( "In-> 17 <<<<----..." );
			    i++;
			    lines += line;
			    
// 			    qDebug( "In-> 18 <<<<- ..." );
			}
			else
			{
			    // Empty Line .... 
			    qDebug( "Empty Line .... " );
// 			    qDebug( "In-> 17 ..." );
			    i++;
			    lines += line;
			    sleep (1);
// 			    qDebug( "In-> 18 ..." );
			    
			}
		    }
		}
		else if (strcmp( line.left( 3 ),"# Ne") == 0 ){
		    // next packet so lets leave the while( read_all_packet == TRUE ) ...
		    
		    lines += line;
		    
		}
		else{
		    
		    qDebug( "Not looking good <error1> .... " );
		    lines += line;
		}
	    }
	    else{
		
		//qDebug( " den vrika kati na teriazei .... " );
		row++;
		i++;
		lines += line;
		//sleep (1);
	    }
	    
	}
	
	
	// i++;
	// lines += line;
	
    }
    file.close();
}



/*
  **************************************************************************************************************
												 Apply filter(s)  function 
  **************************************************************************************************************
*/


void sniffer::filter()
{
    clear_table();
    bool packet_is_accepted = TRUE;
    sniferTable->removeColumn(0);
    sniferTable->removeColumn(1);
   // int j=0;
   // int j_end = sniferTable->numRows();
    
    
    sniferTable->insertColumns(0);
    sniferTable->insertColumns(1);

    QHeader *th = sniferTable->horizontalHeader();
    th->setLabel( 1, "Ethernet  Destination and Source" );
    th->setLabel( 0, "ID" );
    sniferTable->removeColumn(2);
    
    QStringList lines;
    
        QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/sniffer/sniff_log" );
    
    QFile file( my_path );
    if ( file.open( IO_ReadOnly ) ) {
	QTextStream stream( &file );
	QString line;
	QString about_to_show;
	int i = 1;
	int row=0;
	QString temp;
	
	while ( !stream.atEnd() ) {
	    line = stream.readLine(); // line of text excluding '\n'	    ;	    
	    if( line.startsWith( "# New packet with id" ) == TRUE){	    
	    
	    sniferTable->insertRows(row);
	    int end = line.find( QRegExp(" #"), 0 );
	    int str = line.find( QRegExp("mber "), 0 );		
	    sniferTable->setText(row,0,line.mid( str+4, end)); // the ID number only at the first field
	    about_to_show="Ethernet";
	    
	    // I am at : # New packet with id ... and overall packet number ... #
	    lines += line;
	    line = stream.readLine();
	    // Just moved one line and went to *****ETHERNET HEADER*******
	    
	    lines += line;
	    line = stream.readLine();
	    // Just moved one line
	    
	    // I am at :	Destination:
	    
	    QString packetID;
	    
	   
	    
	      
	    //====================================
	    if (! strcmp(l1dest->text (),"") == 0){
		if (!line.isEmpty()){
		    if( line.startsWith( "Destination:" ) == TRUE){
			temp=l1dest->text();
			
			if (line.contains(temp)==1){			    
			    qDebug( "We get this -> l1dest ... " );
			}
			else{
			    packet_is_accepted=FALSE;
			}
		    }
		}
	    }
	    //====================================
	     packetID = line.remove( 0, 12);
	     
	    packetID.append(" --> ");
	    
	    lines += line;
	    line = stream.readLine();
	    // Just moved one line
	    
	    // I am at :	Source
	    
	    
	  
	    //====================================
	    if (! strcmp(l1source->text (),"") == 0){
		if (!line.isEmpty()){
		    if( line.startsWith( "Source:" ) == TRUE){
			temp=l1source->text();
			
			if (line.contains(temp)==1){
			    qDebug( "we get this -> l1source ... " );			    
			}
			else{
			    packet_is_accepted=FALSE;
			}
		    }
		}
	    }
	    //====================================
	      
	    packetID.append(line.remove( 0, 7));
	   
	    sniferTable->setText(row,1,packetID);
	    row++;
	    
	}
	    
	    else{
		if( packet_is_accepted==TRUE){
		    
		     if( line.startsWith( "Ethernet type is an ARP packet" ) == TRUE){
			 packet_is_accepted=FALSE;
			}
		    
		    // Level 2 IP - ARP
		    
		    //====================================
		    if (! strcmp(l2source->text (),"") == 0){
			if (!line.isEmpty()){
			    if( line.startsWith( "Source:" ) == TRUE){
				temp=l2source->text();
				
				if (line.contains(temp)==1){
				    qDebug( "We get this-> l2source ... " );
				}
				else{
				    packet_is_accepted=FALSE;
				}
			    }
			}
		    }
		    //====================================		
		    
		    
		    //====================================
		    if (! strcmp(l2dest->text (),"") == 0){
			if (!line.isEmpty()){
			    if( line.startsWith( "Destination:" ) == TRUE){
				temp=l2dest->text();
				
				if (line.contains(temp)==1){
				    qDebug( "We get this -> l2dest ... " );
				}
				else{
				    packet_is_accepted=FALSE;
				}
			    }
			}
		    }
		    //====================================				
		    
		    
		    //====================================
		    if (! strcmp(l2ttl->text (),"") == 0){
			if (!line.isEmpty()){
			    if( line.startsWith( "TTL:" ) == TRUE){
				temp=l2ttl->text();
				
				if (line.contains(temp)==1){
				    qDebug( "We get this ->  l2ttl ... " );
				}
				else{
				    packet_is_accepted=FALSE;
				}
			    }
			}
		    }
		    //====================================
		    
		    
		    //Level 3 - TCP - UDP - ICMP
		    
		    //====================================
		    if (! strcmp(l3destport->text (),"") == 0){
			if (!line.isEmpty()){
			    if( line.startsWith( "Destination port" ) == TRUE){
				temp=l3destport->text();
				
				if (line.contains(temp)==1){
				     qDebug( "we get this ->  l3destport ... " );
				}
				else{
				    packet_is_accepted=FALSE;
				}
			    }
			}
		    }
		    //====================================
		    
		    //====================================
		    if (! strcmp(l3seqnum->text (),"") == 0){
			if (!line.isEmpty()){
			    if( line.startsWith( "Sequence number" ) == TRUE){
				temp=l3seqnum->text();
				
				if (line.contains(temp)==1){
				    qDebug( "We get this -> l3seqnum ... " );
				}
				else{
				    packet_is_accepted=FALSE;
				}
			    }
			}
		    }
		    //====================================
		    
		    //====================================
		    if (! strcmp(l3checksum->text (),"") == 0){
			if (!line.isEmpty()){
			    if( line.contains( "Checksum" ) == 1){
				temp=l3checksum->text();
				
				if (line.contains(temp)==1){
					qDebug( "We get this -> l3checksum ... " );
				}
				else{
				    packet_is_accepted=FALSE;
				}
			    }
			}
		    }
		    //====================================
		    
		    
		    //Level 4 - AODV
		    
		    //l4type;
		    //l4id;
		    //l4dest;
		    //l4destseq;
		    //	l4orig;
		    //l4origseq;
		    //l4hopcou;
		    
		    
		}
		else{
		    //  packet_is_accepted = FALSE
		}
	    }    
	    
	    
	     /*
	      NOTE: if we meet the packet constarins then we procced to the next packet 
	      else  we remove the current one and we procced.
	      */
	    
	    if( packet_is_accepted==TRUE){
		// do nothing
	    }
	    else{
		row--;
		sniferTable->setText(row,1,"");
		sniferTable->setText(row,0,"");
		//sniferTable->removeRow(row);
		packet_is_accepted=TRUE;
	    }
	    
	    i++;
	    lines += line;
	    

	}
	file.close();
    }  
    
}


void sniffer::getnewdumpfile()
{
    clear_table();
    
    QString node_name;
    QString node_ip;

    QProcess *proc; 
    
    system("rm  $MLABROOT/sniffer/sniff_log");
    parse_bar->setProgress(0);
    transfer->setProgress(0);
    proc = new QProcess( this );
    proc->addArgument( "get_latest_sniff_file.sh" );
    node_name=snifferSource->text(snifferSource->currentItem());
transfer->setProgress(0);

    
    
    QString text;
    QDir d;
    d.setFilter( QDir::Files | QDir::NoSymLinks );
    d.setSorting( QDir::Name );
    
    QString my_path;
    my_path=getenv ("MLABROOT");
    my_path.append( "/network/nodes" );
    
    QDir::setCurrent (my_path);
    const QFileInfoList *list = d.entryInfoList();
    QFileInfoListIterator it( *list );
    QFileInfo *fi;
     int row=0;

    
    while ( (fi = it.current()) != 0 ) {
	text=fi->fileName().latin1();
	
	if(text == node_name){
	    
	    
	    QString my_path1;
	    my_path1=getenv ("MLABROOT");
	    my_path1.append( "/network/nodes" );
	    
	    QDir::setCurrent (my_path1);
	    
	    QStringList lines;
	    QFile file(text);
	    
	    if ( file.open( IO_ReadOnly ) ) {
		QTextStream stream( &file );
		QString line;
		//QString s;
		// int i = 1;
		while ( !stream.atEnd() ) {
		    line = stream.readLine(); // line of text excluding '\n'
		    node_ip = line.section( "__", 4, 4 );  // s == Wired IP
		    lines += line;
		}
		file.close();
	    }
	}
	++it;
	row++;
    }
    
transfer->setProgress(10);
    sleep(1);
    int z = 10;
  // l1source->setText(node_ip);
    proc->addArgument(node_ip);
    
    if ( !proc->start() ) {
	printf( "	function ->getnewdumpfile()<Fatal error Could not start the uic command. script name :get_latest_sniff_file.sh . Quit\n <--- \n" );

    }
    
    while ( proc->isRunning () == TRUE ){
	printf("Please wait .... \n ");
		sleep(1);
	transfer->setProgress(z);
	z++;
    }
   transfer->setProgress(100); 
    parse();
    
}


void sniffer::clear_table()
{
    //bool packet_is_accepted = TRUE;
    
    int j;
    int z=0;
    while (z<100){
	
	int j_end = sniferTable->numRows() -1 ;
	
	for(j=1; j<=j_end ;j++){
	    sniferTable->removeRow(j);
	}
	
	z++;    
	    }
    
	
  sniferTable->removeRow(1);





}
